package com.ibm.sip.test;

import com.sirf.studio.geoagent.AgentListener;
import com.sirf.studio.geoagent.GeoAlert;
import com.sirf.studio.geoagent.User;
import com.sirf.studio.geoagent.AgentProvisioningProvider;
import com.sirf.studio.geoagent.factory.GeoAgentFactory;
import com.sirf.studio.location.Location;

import com.ibm.sip.test.DemoAdapterSIP;

public class DemoAdapterListener implements AgentListener {
	
	private DemoAdapterSIP demoAdapter;
	private final static DemoAdapterListener INSTANCE = new DemoAdapterListener();
	private DemoAdapterListener(){ }
	
	public static DemoAdapterListener getInstance() {
		return INSTANCE;
	}

	public void setAdapter(DemoAdapterSIP adapter){
		demoAdapter = adapter;
	}

	// Test method only, used by DemoAdapterHTTP - does not include Location arg
	public boolean testOnlyAlertTriggered(User user, GeoAlert alert) {
		if (user != null && alert != null) {
			demoAdapter.publishAlert(user.getMsid(),alert.getAlertMessage());
		}
		else	{
			System.out.println("Alert not defined.");
			return false;
		}
		return true;
	}
	
	public boolean alertTriggered(User user, GeoAlert alert, Location loc) {
		if (user != null && alert != null) {
			demoAdapter.publishAlert(user.getMsid(),alert.getAlertMessage());
		}
		else	{
			System.out.println("Alert not defined.");
			return false;
		}
		return true;
	}

	public boolean alertTriggered(String userId, String alertId, Location loc) {
		GeoAgentFactory _fac = GeoAgentFactory.getInstance();
		AgentProvisioningProvider provider = _fac.getAgentProvisioningProvider();
		GeoAlert alert = provider.findAlert(alertId);
		if (alert != null) {
			demoAdapter.publishAlert(userId, alert.getAlertMessage());
		}
		else {
			System.out.println("Alert id = " + alertId + " for user = " + userId + " not found.");
			return false;
		}
		return true;
	}

	public void locationUpdated(User user, Location loc) {
		demoAdapter.publishAlert(user.getMsid(), loc.toString());

	}

}
